import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Link here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Player extends Sprite
{
    
    private static final int UP = 3;
    private static final int DOWN = 4;    
    private static final int RIGHT = 1;
    private static final int LEFT = 2;
    public int direction;
    private int preyEaten = 0; //---------------------------------------
    private int foodEaten = 0;
    private int coinEaten = 0;
    private int oozeEaten = 0;
    private int loadFull = 0;

    public int moveAmount = 2;

    private Animation faceUp;
    private Animation faceDown;
    private Animation faceLeft;
    private Animation faceRight;

    private Animation runRight;
    private Animation runLeft;
    private Animation runDown;
    private Animation runUp;
    private static GreenfootImage[] runDownImages;
    private static GreenfootImage faceDownImg;
    private static GreenfootImage[] runUpImages;
    private static GreenfootImage faceUpImg;
    private static GreenfootImage[] runLeftImages;
    private static GreenfootImage faceLeftImg;
    private static GreenfootImage[] runRightImages;
    private static GreenfootImage faceRightImg;
    private static final int RUN_COUNT = 8;
    public Player()
    {
        initializeImages();
        runRight = new Animation();
        runLeft = new Animation();
        runUp = new Animation();
        runDown = new Animation();
        for (int i = 0; i < runDownImages.length; i++)
        {
            runDown.addImage(runDownImages[i]);
        }
        for (int i = 0; i < runUpImages.length; i++)
        {
            runUp.addImage(runUpImages[i]);
        }
        for (int i = 0; i < runLeftImages.length; i++)
        {
            runLeft.addImage(runLeftImages[i]);
        }
        for (int i = 0; i < runRightImages.length; i++)
        {
            runRight.addImage(runRightImages[i]);
        }
        faceLeft = new Animation();
        faceLeft.addImage(faceLeftImg);
        faceRight = new Animation();
        faceRight.addImage(faceRightImg);
        faceDown = new Animation();
        faceDown.addImage(faceDownImg);
        faceUp = new Animation();
        faceUp.addImage(faceUpImg);
        setAnimation(faceDown);
        direction = DOWN;

    } 

    public static void initializeImages()
    {

        if (runDownImages == null && runUpImages == null && runRightImages == null && runLeftImages == null)
        {
            runDownImages = new GreenfootImage[RUN_COUNT];
            for (int i = 0; i < runDownImages.length; i++)
            {
                String fileNameDown = "runDown" + (i + 1) + ".gif";
                runDownImages[i] = new GreenfootImage(fileNameDown);
            }

            runUpImages = new GreenfootImage[RUN_COUNT];
            for (int i = 0; i < runUpImages.length; i++)
            {
                String fileNameUp = "runUp" + (i + 1) + ".gif";
                runUpImages[i] = new GreenfootImage(fileNameUp);
            }
            runLeftImages = new GreenfootImage[RUN_COUNT];
            for (int i = 0; i < runLeftImages.length; i++)
            {
                String fileNameLeft = "runLeft" + (i + 1) + ".gif";
                runLeftImages[i] = new GreenfootImage(fileNameLeft);
            }
            runRightImages = new GreenfootImage[RUN_COUNT];
            for (int i = 0; i < runRightImages.length; i++)
            {
                String fileNameRight = "runRight" + (i + 1) + ".gif";
                runRightImages[i] = new GreenfootImage(fileNameRight);
            }
        }

        // Running ^^   Standing vv
        if (faceDownImg == null && faceUpImg == null && faceLeftImg == null && faceRightImg == null)
        {
            faceDownImg = new GreenfootImage("faceDown.gif");
            faceUpImg = new GreenfootImage("faceUp.gif");
            faceLeftImg = new GreenfootImage("faceLeft.gif");
            faceRightImg = new GreenfootImage("faceDown.gif");
        }
    }

    public void act()
    {
        controls();
        tryToEatOoze();
        tryToEatCoin();
        tryToEmptyLoad();
        idle();

    }

    public void controls()
    {   

        if (Greenfoot.isKeyDown("right"))
        {
            runRight();
            direction = RIGHT;
            if (anim != null)
            {
                anim.update();
                setImage(anim.getImage());
            }
        }
        if (Greenfoot.isKeyDown("left"))
        {
            runLeft();
            direction = LEFT;
            if (anim != null)
            {
                anim.update();
                setImage(anim.getImage());
            }
        }
        if (Greenfoot.isKeyDown("up"))
        {
            runUp();
            direction = UP;
            if (anim != null)
            {
                anim.update();
                setImage(anim.getImage());
            }
        }
        if (Greenfoot.isKeyDown("down"))
        {
            runDown();
            direction = DOWN;
            if (anim != null)
            {
                anim.update();
                setImage(anim.getImage());
            }

        }
        else
        {

            if (direction == DOWN)
            {
                setAnimation(faceDown);

            }
            if (direction == UP)
            {
                setAnimation(faceUp);

            }
            if (direction == LEFT)
            {
                setAnimation(faceLeft);

            }
            if (direction == RIGHT)
            {
                setAnimation(faceRight);

            }
        }
    }
    public void runRight()
    {
        setAnimation(runRight);
        setLocation(getX() + moveAmount,getY());
        direction = RIGHT;

    }

    public void runLeft()
    {
        setAnimation(runLeft);
        setLocation(getX() - moveAmount,getY());
        direction = LEFT;

    }
    public void runUp()
    {
        setAnimation(runUp);
        setLocation(getX() , getY()- moveAmount);
        direction = UP;

    }

    public void runDown()
    {
        setAnimation(runDown);
        setLocation(getX() , getY()+ moveAmount);
        direction = DOWN;

    }
 // Try to eat Food if it's available.
    public void tryToEatCoin()
    {
        if(canSee(Coin.class))
        {
            eat(Coin.class);
            coinEaten++;
            //Greenfoot.playSound("bump.wav");
            //if(coinEaten == 4){
            //    gameOver();
            //}
        }
    }

// Try to empty load if it's available.
    public void tryToEmptyLoad()
    {
        if(canSee(Barrel.class))
        {
            if(loadFull == 1)
            {
            loadFull = 0;
            // ADD TO SCORE HERE
            Greenfoot.playSound("capture.wav");
            if(oozeEaten == 5){
                winGame();
            }
        }
        }
    }
    
    // Try to eat Prey if it's available.
    public void tryToEatOoze()
    {
        if(canSee(Ooze.class))
        {
            if(loadFull == 0)
            {
            eat(Ooze.class);
            oozeEaten++;
            loadFull = 1;
            Greenfoot.playSound("snorfit.wav");
            //if(oozeEaten == 6){
            //    gameOver();
            //}
            }
        }
    }

    
   // We have won the game
    
    public void winGame()
    {
        //Greenfoot.playSound("hyena.wav");
        
        Greenfoot.stop();
    }

    // We have died
    
    public void gameOver()
    {
        Greenfoot.playSound("gameover.wav");
        Greenfoot.stop();
    }


    public void idle()
    {

    }
}

